Subject: ‘guix offload test’provides insufficient details upon failure

From: [email-masked] (Ludovic Courtès)
Date: Tue, 07 Mar 2017 12:01:11 +0100

See message below.

Subject: Re: guix offload, (test returned #<unspecified>)
From: Myles English <[email-masked]>
To: Ludovic Courtès <[email-masked]>
Cc: help-guix <[email-masked]>
Date: Mon, 06 Mar 2017 23:23:01 +0000

Hi Ludo',

on [2017-03-06] at 10:52 Ludovic Courtès writes:

> Myles English <[email-masked]> skribis:
>
>> Two hosts, setup the same as far as I can see, behave differently when
>> trying to offload builds, any idea how I can get more information on
>> what the #<unspecified> might indicate?  Looking at
>> guix/scripts/offload.scm:551 suggests the result is not a string.
>>
>> $ guix offload test
>> guix offload: testing 2 build machines defined in '/etc/guix/machines.scm'...
>> guix offload: 'host1.mydomain.co.uk' is running guile (GNU Guile) 2.0.13
>> guix offload: 'host2.mydomain.co.uk' is running guile (GNU Guile) 2.0.13
>> guix offload: Guix is usable on 'host1.mydomain.co.uk' (test returned "/gnu/store/883yjkl46dxw9mzykykmbs0yzwyxm17z-test")
>> guix offload: error: failed to use Guix module on 'host2.mydomain.co.uk'
>> (test returned #<unspecified>)
>
> What you see here most likely means that host2 threw an exception while
> executing this code:
>
>   http://git.savannah.gnu.org/cgit/guix.git/tree/guix/scripts/offload.scm#n543
>
> The reason could be:
>
>   1. That the (guix …) modules could not be found in the search path
>      (your tests suggest this is not the case);
>
>   2. That an exception was thrown, for instance because the ‘with-store’
>      form failed to connect to the daemon on that machine (is the daemon
>      running on that machine? Is it listening on
>      /var/guix/daemon-socket/socket and not some other place?).

Yes, that was probably the problem.  I have since updated the host
systems, rebooted, restarted the daemons and now it works, thanks.

> We should definitely improve that and provide details about the
> exception, at least.

Yes, I agree, because 'guix offload test' should provide useful details
when it fails and not just when it succeeds.

Myles